/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.veranstaltung;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.veranstaltung.boundary.AbstractVeranstaltungSearchParameters;
import de.ivu.elect.business.veranstaltung.boundary.VeranstaltungChangeEvent;
import de.ivu.elect.business.veranstaltung.boundary.VeranstaltungConversationStore;
import de.ivu.elect.business.veranstaltung.boundary.VeranstaltungExtendedDAO;
import de.ivu.elect.business.veranstaltung.boundary.VeranstaltungSearch;
import de.ivu.elect.business.veranstaltung.boundary.VeranstaltungSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.veranstaltung.entity.Veranstaltung;
import de.ivu.elect.business.veranstaltung.entity.VeranstaltungMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractVeranstaltungSearchView.COMPONENT_NAME)
@View(viewId = AbstractVeranstaltungSearchView.VIEW_ID, useCase = UseCasePermission.VERANSTALTUNG_SEARCH)
public abstract class AbstractVeranstaltungSearchView extends AbstractElectSearchView<Veranstaltung> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "veranstaltungSearchView";
  
  public static final String VIEW_ID = "/veranstaltung/veranstaltung-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractVeranstaltungSearchView requestHandler;

  @Inject
  private transient VeranstaltungExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(VeranstaltungConversationStore.class)
  protected transient VeranstaltungConversationStore conversationStore;

  @Inject
  protected transient VeranstaltungSearch search;

  @Inject
  @ConversationGroup(AbstractVeranstaltungSearchParameters.class)
  protected transient VeranstaltungSearchParameters searchParameters;

  @Inject
  protected transient VeranstaltungMeta entityMeta;

  public AbstractVeranstaltungSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Veranstaltung getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Veranstaltung entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public VeranstaltungSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Veranstaltung> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Veranstaltung> create();
  }

  @Override
  public List<Veranstaltung> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Veranstaltung> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onVeranstaltungChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) VeranstaltungChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractVeranstaltungSearchView {

    @View
    @Inject
    private transient Instance<AbstractVeranstaltungSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractVeranstaltungSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
